fd18b392363c47f0e17135c4d767261092559117
[arvados.git] / build / run-build-packages.sh
1 #!/bin/bash
2
3 . `dirname "$(readlink -f "$0")"`/run-library.sh
4 . `dirname "$(readlink -f "$0")"`/libcloud-pin
5
6 read -rd "\000" helpmessage <<EOF
7 $(basename $0): Build Arvados packages
8
9 Syntax:
10         WORKSPACE=/path/to/arvados $(basename $0) [options]
11
12 Options:
13
14 --build-bundle-packages  (default: false)
15     Build api server and workbench packages with vendor/bundle included
16 --debug
17     Output debug information (default: false)
18 --target
19     Distribution to build packages for (default: debian7)
20 --command
21     Build command to execute (defaults to the run command defined in the
22     Docker image)
23
24 WORKSPACE=path         Path to the Arvados source tree to build packages from
25
26 EOF
27
28 EXITCODE=0
29 DEBUG=${ARVADOS_DEBUG:-0}
30 TARGET=debian7
31 COMMAND=
32
33 PARSEDOPTS=$(getopt --name "$0" --longoptions \
34     help,build-bundle-packages,debug,target: \
35     -- "" "$@")
36 if [ $? -ne 0 ]; then
37     exit 1
38 fi
39
40 eval set -- "$PARSEDOPTS"
41 while [ $# -gt 0 ]; do
42     case "$1" in
43         --help)
44             echo >&2 "$helpmessage"
45             echo >&2
46             exit 1
47             ;;
48         --target)
49             TARGET="$2"; shift
50             ;;
51         --debug)
52             DEBUG=1
53             ;;
54         --command)
55             COMMAND="$2"; shift
56             ;;
57         --)
58             if [ $# -gt 1 ]; then
59                 echo >&2 "$0: unrecognized argument '$2'. Try: $0 --help"
60                 exit 1
61             fi
62             ;;
63     esac
64     shift
65 done
66
67 if [[ "$COMMAND" != "" ]]; then
68   COMMAND="/usr/local/rvm/bin/rvm-exec default bash /jenkins/$COMMAND --target $TARGET"
69 fi
70
71 STDOUT_IF_DEBUG=/dev/null
72 STDERR_IF_DEBUG=/dev/null
73 DASHQ_UNLESS_DEBUG=-q
74 if [[ "$DEBUG" != 0 ]]; then
75     STDOUT_IF_DEBUG=/dev/stdout
76     STDERR_IF_DEBUG=/dev/stderr
77     DASHQ_UNLESS_DEBUG=
78 fi
79
80 declare -a PYTHON_BACKPORTS PYTHON3_BACKPORTS
81
82 PYTHON2_VERSION=2.7
83 PYTHON3_VERSION=$(python3 -c 'import sys; print("{v.major}.{v.minor}".format(v=sys.version_info))')
84
85 case "$TARGET" in
86     debian7)
87         FORMAT=deb
88         PYTHON2_PACKAGE=python$PYTHON2_VERSION
89         PYTHON2_PKG_PREFIX=python
90         PYTHON3_PACKAGE=python$PYTHON3_VERSION
91         PYTHON3_PKG_PREFIX=python3
92         PYTHON_BACKPORTS=(python-gflags google-api-python-client==1.4.2 \
93             oauth2client==1.5.2 pyasn1==0.1.7 pyasn1-modules==0.0.5 \
94             rsa uritemplate httplib2 ws4py pykka six pyexecjs jsonschema \
95             ciso8601 pycrypto backports.ssl_match_hostname llfuse==0.41.1 \
96             'pycurl<7.21.5' contextlib2 pyyaml 'rdflib>=4.2.0' \
97             shellescape mistune typing avro)
98         PYTHON3_BACKPORTS=(docker-py six requests websocket-client)
99         ;;
100     debian8)
101         FORMAT=deb
102         PYTHON2_PACKAGE=python$PYTHON2_VERSION
103         PYTHON2_PKG_PREFIX=python
104         PYTHON3_PACKAGE=python$PYTHON3_VERSION
105         PYTHON3_PKG_PREFIX=python3
106         PYTHON_BACKPORTS=(python-gflags google-api-python-client==1.4.2 \
107             oauth2client==1.5.2 pyasn1==0.1.7 pyasn1-modules==0.0.5 \
108             rsa uritemplate httplib2 ws4py pykka six pyexecjs jsonschema \
109             ciso8601 pycrypto backports.ssl_match_hostname llfuse==0.41.1 \
110             'pycurl<7.21.5' pyyaml 'rdflib>=4.2.0' \
111             shellescape mistune typing avro)
112         PYTHON3_BACKPORTS=(docker-py six requests websocket-client)
113         ;;
114     ubuntu1204)
115         FORMAT=deb
116         PYTHON2_PACKAGE=python$PYTHON2_VERSION
117         PYTHON2_PKG_PREFIX=python
118         PYTHON3_PACKAGE=python$PYTHON3_VERSION
119         PYTHON3_PKG_PREFIX=python3
120         PYTHON_BACKPORTS=(python-gflags google-api-python-client==1.4.2 \
121             oauth2client==1.5.2 pyasn1==0.1.7 pyasn1-modules==0.0.5 \
122             rsa uritemplate httplib2 ws4py pykka six pyexecjs jsonschema \
123             ciso8601 pycrypto backports.ssl_match_hostname llfuse==0.41.1 \
124             contextlib2 'pycurl<7.21.5' pyyaml 'rdflib>=4.2.0' \
125             shellescape mistune typing avro isodate)
126         PYTHON3_BACKPORTS=(docker-py six requests websocket-client)
127         ;;
128     ubuntu1404)
129         FORMAT=deb
130         PYTHON2_PACKAGE=python$PYTHON2_VERSION
131         PYTHON2_PKG_PREFIX=python
132         PYTHON3_PACKAGE=python$PYTHON3_VERSION
133         PYTHON3_PKG_PREFIX=python3
134         PYTHON_BACKPORTS=(pyasn1==0.1.7 pyasn1-modules==0.0.5 llfuse==0.41.1 ciso8601 \
135             google-api-python-client==1.4.2 six uritemplate oauth2client==1.5.2 httplib2 \
136             rsa 'pycurl<7.21.5' backports.ssl_match_hostname pyyaml 'rdflib>=4.2.0' \
137             shellescape mistune typing avro)
138         PYTHON3_BACKPORTS=(docker-py requests websocket-client)
139         ;;
140     centos6)
141         FORMAT=rpm
142         PYTHON2_PACKAGE=$(rpm -qf "$(which python$PYTHON2_VERSION)" --queryformat '%{NAME}\n')
143         PYTHON2_PKG_PREFIX=$PYTHON2_PACKAGE
144         PYTHON3_PACKAGE=$(rpm -qf "$(which python$PYTHON3_VERSION)" --queryformat '%{NAME}\n')
145         PYTHON3_PKG_PREFIX=$PYTHON3_PACKAGE
146         PYTHON_BACKPORTS=(python-gflags google-api-python-client==1.4.2 \
147             oauth2client==1.5.2 pyasn1==0.1.7 pyasn1-modules==0.0.5 \
148             rsa uritemplate httplib2 ws4py pykka six pyexecjs jsonschema \
149             ciso8601 pycrypto backports.ssl_match_hostname 'pycurl<7.21.5' \
150             python-daemon lockfile llfuse==0.41.1 'pbr<1.0' pyyaml \
151             'rdflib>=4.2.0' shellescape mistune typing avro requests \
152             isodate pyparsing sparqlwrapper html5lib keepalive)
153         PYTHON3_BACKPORTS=(docker-py six requests websocket-client)
154         export PYCURL_SSL_LIBRARY=nss
155         ;;
156     *)
157         echo -e "$0: Unknown target '$TARGET'.\n" >&2
158         exit 1
159         ;;
160 esac
161
162
163 if ! [[ -n "$WORKSPACE" ]]; then
164   echo >&2 "$helpmessage"
165   echo >&2
166   echo >&2 "Error: WORKSPACE environment variable not set"
167   echo >&2
168   exit 1
169 fi
170
171 # Test for fpm
172 fpm --version >/dev/null 2>&1
173
174 if [[ "$?" != 0 ]]; then
175   echo >&2 "$helpmessage"
176   echo >&2
177   echo >&2 "Error: fpm not found"
178   echo >&2
179   exit 1
180 fi
181
182 EASY_INSTALL2=$(find_easy_install -$PYTHON2_VERSION "")
183 EASY_INSTALL3=$(find_easy_install -$PYTHON3_VERSION 3)
184
185 RUN_BUILD_PACKAGES_PATH="`dirname \"$0\"`"
186 RUN_BUILD_PACKAGES_PATH="`( cd \"$RUN_BUILD_PACKAGES_PATH\" && pwd )`"  # absolutized and normalized
187 if [ -z "$RUN_BUILD_PACKAGES_PATH" ] ; then
188   # error; for some reason, the path is not accessible
189   # to the script (e.g. permissions re-evaled after suid)
190   exit 1  # fail
191 fi
192
193 debug_echo "$0 is running from $RUN_BUILD_PACKAGES_PATH"
194 debug_echo "Workspace is $WORKSPACE"
195
196 if [[ -f /etc/profile.d/rvm.sh ]]; then
197     source /etc/profile.d/rvm.sh
198     GEM="rvm-exec default gem"
199 else
200     GEM=gem
201 fi
202
203 # Make all files world-readable -- jenkins runs with umask 027, and has checked
204 # out our git tree here
205 chmod o+r "$WORKSPACE" -R
206
207 # More cleanup - make sure all executables that we'll package are 755
208 find -type d -name 'bin' |xargs -I {} find {} -type f |xargs -I {} chmod 755 {}
209
210 # Now fix our umask to something better suited to building and publishing
211 # gems and packages
212 umask 0022
213
214 debug_echo "umask is" `umask`
215
216 if [[ ! -d "$WORKSPACE/packages/$TARGET" ]]; then
217   mkdir -p $WORKSPACE/packages/$TARGET
218 fi
219
220 # Perl packages
221 debug_echo -e "\nPerl packages\n"
222
223 cd "$WORKSPACE/sdk/perl"
224
225 if [[ -e Makefile ]]; then
226   make realclean >"$STDOUT_IF_DEBUG"
227 fi
228 find -maxdepth 1 \( -name 'MANIFEST*' -or -name "libarvados-perl*.$FORMAT" \) \
229     -delete
230 rm -rf install
231
232 perl Makefile.PL INSTALL_BASE=install >"$STDOUT_IF_DEBUG" && \
233     make install INSTALLDIRS=perl >"$STDOUT_IF_DEBUG" && \
234     fpm_build install/lib/=/usr/share libarvados-perl \
235     "Curoverse, Inc." dir "$(version_from_git)" install/man/=/usr/share/man \
236     "$WORKSPACE/LICENSE-2.0.txt=/usr/share/doc/libarvados-perl/LICENSE-2.0.txt" && \
237     mv --no-clobber libarvados-perl*.$FORMAT "$WORKSPACE/packages/$TARGET/"
238
239 # Ruby gems
240 debug_echo -e "\nRuby gems\n"
241
242 FPM_GEM_PREFIX=$($GEM environment gemdir)
243
244 cd "$WORKSPACE/sdk/ruby"
245 handle_ruby_gem arvados
246
247 cd "$WORKSPACE/sdk/cli"
248 handle_ruby_gem arvados-cli
249
250 cd "$WORKSPACE/services/login-sync"
251 handle_ruby_gem arvados-login-sync
252
253 # Python packages
254 debug_echo -e "\nPython packages\n"
255
256 cd "$WORKSPACE/sdk/pam"
257 handle_python_package
258
259 cd "$WORKSPACE/sdk/python"
260 handle_python_package
261
262 cd "$WORKSPACE/sdk/cwl"
263 handle_python_package
264
265 cd "$WORKSPACE/services/fuse"
266 handle_python_package
267
268 cd "$WORKSPACE/services/nodemanager"
269 handle_python_package
270
271 # arvados-src
272 (
273     set -e
274
275     cd "$WORKSPACE"
276     COMMIT_HASH=$(format_last_commit_here "%H")
277
278     SRC_BUILD_DIR=$(mktemp -d)
279     # mktemp creates the directory with 0700 permissions by default
280     chmod 755 $SRC_BUILD_DIR
281     git clone $DASHQ_UNLESS_DEBUG "$WORKSPACE/.git" "$SRC_BUILD_DIR"
282     cd "$SRC_BUILD_DIR"
283
284     # go into detached-head state
285     git checkout $DASHQ_UNLESS_DEBUG "$COMMIT_HASH"
286     echo "$COMMIT_HASH" >git-commit.version
287
288     cd "$SRC_BUILD_DIR"
289     PKG_VERSION=$(version_from_git)
290     cd $WORKSPACE/packages/$TARGET
291     fpm_build $SRC_BUILD_DIR/=/usr/local/arvados/src arvados-src 'Curoverse, Inc.' 'dir' "$PKG_VERSION" "--exclude=usr/local/arvados/src/.git" "--url=https://arvados.org" "--license=GNU Affero General Public License, version 3.0" "--description=The Arvados source code" "--architecture=all"
292
293     rm -rf "$SRC_BUILD_DIR"
294 )
295
296 # On older platforms we need to publish a backport of libfuse >=2.9.2,
297 # and we need to build and install it here in order to even build an
298 # llfuse package.
299 cd $WORKSPACE/packages/$TARGET
300 if [[ $TARGET =~ ubuntu1204 ]]; then
301     # port libfuse 2.9.2 to Ubuntu 12.04
302     LIBFUSE_DIR=$(mktemp -d)
303     (
304         cd $LIBFUSE_DIR
305         # download fuse 2.9.2 ubuntu 14.04 source package
306         file="fuse_2.9.2.orig.tar.xz" && curl -L -o "${file}" "http://archive.ubuntu.com/ubuntu/pool/main/f/fuse/${file}"
307         file="fuse_2.9.2-4ubuntu4.14.04.1.debian.tar.xz" && curl -L -o "${file}" "http://archive.ubuntu.com/ubuntu/pool/main/f/fuse/${file}"
308         file="fuse_2.9.2-4ubuntu4.14.04.1.dsc" && curl -L -o "${file}" "http://archive.ubuntu.com/ubuntu/pool/main/f/fuse/${file}"
309
310         # install dpkg-source and dpkg-buildpackage commands
311         apt-get install -y --no-install-recommends dpkg-dev
312
313         # extract source and apply patches
314         dpkg-source -x fuse_2.9.2-4ubuntu4.14.04.1.dsc
315         rm -f fuse_2.9.2.orig.tar.xz fuse_2.9.2-4ubuntu4.14.04.1.debian.tar.xz fuse_2.9.2-4ubuntu4.14.04.1.dsc
316
317         # add new version to changelog
318         cd fuse-2.9.2
319         (
320             echo "fuse (2.9.2-5) precise; urgency=low"
321             echo
322             echo "  * Backported from trusty-security to precise"
323             echo
324             echo " -- Joshua Randall <jcrandall@alum.mit.edu>  Thu, 4 Feb 2016 11:31:00 -0000"
325             echo
326             cat debian/changelog
327         ) > debian/changelog.new
328         mv debian/changelog.new debian/changelog
329
330         # install build-deps and build
331         apt-get install -y --no-install-recommends debhelper dh-autoreconf libselinux-dev
332         dpkg-buildpackage -rfakeroot -b
333     )
334     fpm_build "$LIBFUSE_DIR/fuse_2.9.2-5_amd64.deb" fuse "Ubuntu Developers" deb "2.9.2" --iteration 5
335     fpm_build "$LIBFUSE_DIR/libfuse2_2.9.2-5_amd64.deb" libfuse2 "Ubuntu Developers" deb "2.9.2" --iteration 5
336     fpm_build "$LIBFUSE_DIR/libfuse-dev_2.9.2-5_amd64.deb" libfuse-dev "Ubuntu Developers" deb "2.9.2" --iteration 5
337     dpkg -i \
338         "$WORKSPACE/packages/$TARGET/fuse_2.9.2-5_amd64.deb" \
339         "$WORKSPACE/packages/$TARGET/libfuse2_2.9.2-5_amd64.deb" \
340         "$WORKSPACE/packages/$TARGET/libfuse-dev_2.9.2-5_amd64.deb"
341     apt-get -y --no-install-recommends -f install
342     rm -rf $LIBFUSE_DIR
343 elif [[ $TARGET =~ centos6 ]]; then
344     # port fuse 2.9.2 to centos 6
345     # install tools to build rpm from source
346     yum install -y rpm-build redhat-rpm-config
347     LIBFUSE_DIR=$(mktemp -d)
348     (
349         cd "$LIBFUSE_DIR"
350         # download fuse 2.9.2 centos 7 source rpm
351         file="fuse-2.9.2-6.el7.src.rpm" && curl -L -o "${file}" "http://vault.centos.org/7.2.1511/os/Source/SPackages/${file}"
352         (
353             # modify source rpm spec to remove conflict on filesystem version
354             mkdir -p /root/rpmbuild/SOURCES
355             cd /root/rpmbuild/SOURCES
356             rpm2cpio ${LIBFUSE_DIR}/fuse-2.9.2-6.el7.src.rpm | cpio -i
357             perl -pi -e 's/Conflicts:\s*filesystem.*//g' fuse.spec
358         )
359         # build rpms from source 
360         rpmbuild -bb /root/rpmbuild/SOURCES/fuse.spec
361         rm -f fuse-2.9.2-6.el7.src.rpm
362         # move built RPMs to LIBFUSE_DIR
363         mv "/root/rpmbuild/RPMS/x86_64/fuse-2.9.2-6.el6.x86_64.rpm" ${LIBFUSE_DIR}/
364         mv "/root/rpmbuild/RPMS/x86_64/fuse-libs-2.9.2-6.el6.x86_64.rpm" ${LIBFUSE_DIR}/
365         mv "/root/rpmbuild/RPMS/x86_64/fuse-devel-2.9.2-6.el6.x86_64.rpm" ${LIBFUSE_DIR}/
366         rm -rf /root/rpmbuild
367     )
368     fpm_build "$LIBFUSE_DIR/fuse-libs-2.9.2-6.el6.x86_64.rpm" fuse-libs "Centos Developers" rpm "2.9.2" --iteration 5
369     fpm_build "$LIBFUSE_DIR/fuse-2.9.2-6.el6.x86_64.rpm" fuse "Centos Developers" rpm "2.9.2" --iteration 5 --no-auto-depends
370     fpm_build "$LIBFUSE_DIR/fuse-devel-2.9.2-6.el6.x86_64.rpm" fuse-devel "Centos Developers" rpm "2.9.2" --iteration 5 --no-auto-depends
371     yum install -y \
372         "$WORKSPACE/packages/$TARGET/fuse-libs-2.9.2-5.x86_64.rpm" \
373         "$WORKSPACE/packages/$TARGET/fuse-2.9.2-5.x86_64.rpm" \
374         "$WORKSPACE/packages/$TARGET/fuse-devel-2.9.2-5.x86_64.rpm"
375 fi
376
377 # Go binaries
378 cd $WORKSPACE/packages/$TARGET
379 export GOPATH=$(mktemp -d)
380 package_go_binary services/keepstore keepstore \
381     "Keep storage daemon, accessible to clients on the LAN"
382 package_go_binary services/keepproxy keepproxy \
383     "Make a Keep cluster accessible to clients that are not on the LAN"
384 package_go_binary services/keep-web keep-web \
385     "Static web hosting service for user data stored in Arvados Keep"
386 package_go_binary services/datamanager arvados-data-manager \
387     "Ensure block replication levels, report disk usage, and determine which blocks should be deleted when space is needed"
388 package_go_binary services/arv-git-httpd arvados-git-httpd \
389     "Provide authenticated http access to Arvados-hosted git repositories"
390 package_go_binary services/crunchstat crunchstat \
391     "Gather cpu/memory/network statistics of running Crunch jobs"
392 package_go_binary tools/keep-rsync keep-rsync \
393     "Copy all data from one set of Keep servers to another"
394 package_go_binary sdk/go/crunchrunner crunchrunner \
395     "Crunchrunner executes a command inside a container and uploads the output"
396
397 # The Python SDK
398 # Please resist the temptation to add --no-python-fix-name to the fpm call here
399 # (which would remove the python- prefix from the package name), because this
400 # package is a dependency of arvados-fuse, and fpm can not omit the python-
401 # prefix from only one of the dependencies of a package...  Maybe I could
402 # whip up a patch and send it upstream, but that will be for another day. Ward,
403 # 2014-05-15
404 cd $WORKSPACE/packages/$TARGET
405 rm -rf "$WORKSPACE/sdk/python/build"
406 fpm_build $WORKSPACE/sdk/python "${PYTHON2_PKG_PREFIX}-arvados-python-client" 'Curoverse, Inc.' 'python' "$(awk '($1 == "Version:"){print $2}' $WORKSPACE/sdk/python/arvados_python_client.egg-info/PKG-INFO)" "--url=https://arvados.org" "--description=The Arvados Python SDK" --deb-recommends=git
407
408 # cwl-runner
409 cd $WORKSPACE/packages/$TARGET
410 rm -rf "$WORKSPACE/sdk/cwl/build"
411 fpm_build $WORKSPACE/sdk/cwl "${PYTHON2_PKG_PREFIX}-arvados-cwl-runner" 'Curoverse, Inc.' 'python' "$(awk '($1 == "Version:"){print $2}' $WORKSPACE/sdk/cwl/arvados_cwl_runner.egg-info/PKG-INFO)" "--url=https://arvados.org" "--description=The Arvados CWL runner" --iteration 2
412
413 # schema_salad. This is a python dependency of arvados-cwl-runner,
414 # but we can't use the usual PYTHONPACKAGES way to build this package due to the
415 # intricacies of how version numbers get generated in setup.py: we need version
416 # 1.7.20160316203940. If we don't explicitly list that version with the -v
417 # argument to fpm, and instead specify it as schema_salad==1.7.20160316203940, we get
418 # a package with version 1.7. That's because our gittagger hack is not being
419 # picked up by self.distribution.get_version(), which is called from
420 # https://github.com/jordansissel/fpm/blob/master/lib/fpm/package/pyfpm/get_metadata.py
421 # by means of this command:
422 #
423 # python2.7 setup.py --command-packages=pyfpm get_metadata --output=metadata.json
424 #
425 # So we build this thing separately.
426 #
427 # Ward, 2016-03-17
428 fpm --maintainer='Ward Vandewege <ward@curoverse.com>' -s python -t $FORMAT --exclude=*/dist-packages/tests/* --exclude=*/site-packages/tests/* --deb-ignore-iteration-in-dependencies -n "${PYTHON2_PKG_PREFIX}-schema-salad" --iteration 1 --python-bin python2.7 --python-easyinstall "$EASY_INSTALL2" --python-package-name-prefix "$PYTHON2_PKG_PREFIX" --depends "$PYTHON2_PACKAGE" -v 1.7.20160316203940 schema_salad
429
430 # And for cwltool we have the same problem as for schema_salad. Ward, 2016-03-17
431 fpm --maintainer='Ward Vandewege <ward@curoverse.com>' -s python -t $FORMAT --exclude=*/dist-packages/tests/* --exclude=*/site-packages/tests/* --deb-ignore-iteration-in-dependencies -n "${PYTHON2_PKG_PREFIX}-cwltool" --iteration 1 --python-bin python2.7 --python-easyinstall "$EASY_INSTALL2" --python-package-name-prefix "$PYTHON2_PKG_PREFIX" --depends "$PYTHON2_PACKAGE" -v 1.0.20160325200114 cwltool
432
433 # FPM eats the trailing .0 in the python-rdflib-jsonld package when built with 'rdflib-jsonld>=0.3.0'. Force the version. Ward, 2016-03-25
434 fpm --maintainer='Ward Vandewege <ward@curoverse.com>' -s python -t $FORMAT --exclude=*/dist-packages/tests/* --exclude=*/site-packages/tests/* --deb-ignore-iteration-in-dependencies --verbose --log info -n "${PYTHON2_PKG_PREFIX}-rdflib-jsonld" --iteration 1 --python-bin python2.7 --python-easyinstall "$EASY_INSTALL2" --python-package-name-prefix "$PYTHON2_PKG_PREFIX" --depends "$PYTHON2_PACKAGE" -v 0.3.0 rdflib-jsonld
435
436 # The PAM module
437 if [[ $TARGET =~ debian|ubuntu ]]; then
438     cd $WORKSPACE/packages/$TARGET
439     rm -rf "$WORKSPACE/sdk/pam/build"
440     fpm_build $WORKSPACE/sdk/pam libpam-arvados 'Curoverse, Inc.' 'python' "$(awk '($1 == "Version:"){print $2}' $WORKSPACE/sdk/pam/arvados_pam.egg-info/PKG-INFO)" "--url=https://arvados.org" "--description=PAM module for authenticating shell logins using Arvados API tokens" --depends libpam-python
441 fi
442
443 # The FUSE driver
444 # Please see comment about --no-python-fix-name above; we stay consistent and do
445 # not omit the python- prefix first.
446 cd $WORKSPACE/packages/$TARGET
447 rm -rf "$WORKSPACE/services/fuse/build"
448 fpm_build $WORKSPACE/services/fuse "${PYTHON2_PKG_PREFIX}-arvados-fuse" 'Curoverse, Inc.' 'python' "$(awk '($1 == "Version:"){print $2}' $WORKSPACE/services/fuse/arvados_fuse.egg-info/PKG-INFO)" "--url=https://arvados.org" "--description=The Keep FUSE driver"
449
450 # The node manager
451 cd $WORKSPACE/packages/$TARGET
452 rm -rf "$WORKSPACE/services/nodemanager/build"
453 fpm_build $WORKSPACE/services/nodemanager arvados-node-manager 'Curoverse, Inc.' 'python' "$(awk '($1 == "Version:"){print $2}' $WORKSPACE/services/nodemanager/arvados_node_manager.egg-info/PKG-INFO)" "--url=https://arvados.org" "--description=The Arvados node manager"
454
455 # The Docker image cleaner
456 cd $WORKSPACE/packages/$TARGET
457 rm -rf "$WORKSPACE/services/dockercleaner/build"
458 fpm_build $WORKSPACE/services/dockercleaner arvados-docker-cleaner 'Curoverse, Inc.' 'python3' "$(awk '($1 == "Version:"){print $2}' $WORKSPACE/services/dockercleaner/arvados_docker_cleaner.egg-info/PKG-INFO)" "--url=https://arvados.org" "--description=The Arvados Docker image cleaner"
459
460 # Forked libcloud
461 LIBCLOUD_DIR=$(mktemp -d)
462 (
463     cd $LIBCLOUD_DIR
464     git clone $DASHQ_UNLESS_DEBUG https://github.com/curoverse/libcloud.git .
465     git checkout apache-libcloud-$LIBCLOUD_PIN
466     # libcloud is absurdly noisy without -q, so force -q here
467     OLD_DASHQ_UNLESS_DEBUG=$DASHQ_UNLESS_DEBUG
468     DASHQ_UNLESS_DEBUG=-q
469     handle_python_package
470     DASHQ_UNLESS_DEBUG=$OLD_DASHQ_UNLESS_DEBUG
471 )
472 fpm_build $LIBCLOUD_DIR "$PYTHON2_PKG_PREFIX"-apache-libcloud
473 rm -rf $LIBCLOUD_DIR
474
475 # Python 2 dependencies
476 declare -a PIP_DOWNLOAD_SWITCHES=(--no-deps)
477 # Add --no-use-wheel if this pip knows it.
478 pip wheel --help >/dev/null 2>&1
479 case "$?" in
480     0) PIP_DOWNLOAD_SWITCHES+=(--no-use-wheel) ;;
481     2) ;;
482     *) echo "WARNING: `pip wheel` test returned unknown exit code $?" ;;
483 esac
484
485 for deppkg in "${PYTHON_BACKPORTS[@]}"; do
486     outname=$(echo "$deppkg" | sed -e 's/^python-//' -e 's/[<=>].*//' -e 's/_/-/g' -e "s/^/${PYTHON2_PKG_PREFIX}-/")
487     case "$deppkg" in
488         httplib2|google-api-python-client)
489             # Work around 0640 permissions on some package files.
490             # See #7591 and #7991.
491             pyfpm_workdir=$(mktemp --tmpdir -d pyfpm-XXXXXX) && (
492                 set -e
493                 cd "$pyfpm_workdir"
494                 pip install "${PIP_DOWNLOAD_SWITCHES[@]}" --download . "$deppkg"
495                 tar -xf "$deppkg"-*.tar*
496                 cd "$deppkg"-*/
497                 "python$PYTHON2_VERSION" setup.py $DASHQ_UNLESS_DEBUG egg_info build
498                 chmod -R go+rX .
499                 set +e
500                 # --iteration 2 provides an upgrade for previously built
501                 # buggy packages.
502                 fpm_build . "$outname" "" python "" --iteration 2
503                 # The upload step uses the package timestamp to determine
504                 # whether it's new.  --no-clobber plays nice with that.
505                 mv --no-clobber "$outname"*.$FORMAT "$WORKSPACE/packages/$TARGET"
506             )
507             if [ 0 != "$?" ]; then
508                 echo "ERROR: $deppkg build process failed"
509                 EXITCODE=1
510             fi
511             if [ -n "$pyfpm_workdir" ]; then
512                 rm -rf "$pyfpm_workdir"
513             fi
514             ;;
515         *)
516             fpm_build "$deppkg" "$outname"
517             ;;
518     esac
519 done
520
521 # Python 3 dependencies
522 for deppkg in "${PYTHON3_BACKPORTS[@]}"; do
523     outname=$(echo "$deppkg" | sed -e 's/^python-//' -e 's/[<=>].*//' -e 's/_/-/g' -e "s/^/${PYTHON3_PKG_PREFIX}-/")
524     # The empty string is the vendor argument: these aren't Curoverse software.
525     fpm_build "$deppkg" "$outname" "" python3
526 done
527
528 # Build the API server package
529 handle_rails_package arvados-api-server "$WORKSPACE/services/api" \
530     "$WORKSPACE/agpl-3.0.txt" --url="https://arvados.org" \
531     --description="Arvados API server - Arvados is a free and open source platform for big data science." \
532     --license="GNU Affero General Public License, version 3.0"
533
534 # Build the workbench server package
535 (
536     set -e
537     cd "$WORKSPACE/apps/workbench"
538
539     # We need to bundle to be ready even when we build a package without vendor directory
540     # because asset compilation requires it.
541     bundle install --path vendor/bundle >"$STDOUT_IF_DEBUG"
542
543     # clear the tmp directory; the asset generation step will recreate tmp/cache/assets,
544     # and we want that in the package, so it's easier to not exclude the tmp directory
545     # from the package - empty it instead.
546     rm -rf tmp
547     mkdir tmp
548
549     # Set up application.yml and production.rb so that asset precompilation works
550     \cp config/application.yml.example config/application.yml -f
551     \cp config/environments/production.rb.example config/environments/production.rb -f
552     sed -i 's/secret_token: ~/secret_token: xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx/' config/application.yml
553
554     RAILS_ENV=production RAILS_GROUPS=assets bundle exec rake assets:precompile >/dev/null
555
556     # Remove generated configuration files so they don't go in the package.
557     rm config/application.yml config/environments/production.rb
558 )
559
560 if [[ "$?" != "0" ]]; then
561   echo "ERROR: Asset precompilation failed"
562   EXITCODE=1
563 else
564   handle_rails_package arvados-workbench "$WORKSPACE/apps/workbench" \
565       "$WORKSPACE/agpl-3.0.txt" --url="https://arvados.org" \
566       --description="Arvados Workbench - Arvados is a free and open source platform for big data science." \
567       --license="GNU Affero General Public License, version 3.0"
568 fi
569
570 # clean up temporary GOPATH
571 rm -rf "$GOPATH"
572
573 exit $EXITCODE